package at.reisinger;

/**
 * Erweitert at.reisinger.Cards insofern, dass es im at.reisinger.Stack auch ein Deck gibt
 */
public class Stack extends Cards{
    private Cards deck;

    /**
     * Erstellt einen neuen at.reisinger.Stack aus den at.reisinger.User at.reisinger.Cards und seinem Deck
     * @param cards Alle at.reisinger.Cards des Users
     * @param deck Sein Deck
     */
    public Stack(Cards cards, Cards deck) {
        super(cards.getCards());
        this.deck = deck;
    }

    /**
     * Fügt ein neues Deck in den at.reisinger.Stack ein
     * @param newCards Gesamtes Deck
     */
    public void addDeck(Cards newCards) {
        this.deck = newCards;
    }

    /**
     * Holt das gesamte Deck
     * @return Gesamtes Deck
     */
    public Cards getDeck() {
        return this.deck;
    }

    /**
     * Löscht eine at.reisinger.Card aus dem Deck
     * @param toDel at.reisinger.Card zum löschen
     */
    public void delDeck(Card toDel) {
        this.deck.delCard(toDel);
    }

//    /**
//     * Fügt dem deck eine neue at.reisinger.Card ein
//     * @param toAdd Neue at.reisinger.Card
//     */
//    public void addDeckCard(at.reisinger.Card toAdd){
//        this.deck.addCard(toAdd);
//    }
}
