import at.reisinger.Card;
import at.reisinger.CardType;
import at.reisinger.EffectivnessType;
import at.reisinger.ElementTyp;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertTrue;

public class CardTest {

    @Test
    public void test_getName() {
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.SPELL);
        assertTrue(card.getName().equals("Name"));
    }
    @Test
    public void test_getDamage() {
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.SPELL);
        assertTrue(card.getDamage() == 10);
    }
    @Test
    public void test_getElementType() {
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.SPELL);
        ElementTyp elementTyp = card.getElementTyp();
        assertTrue(elementTyp == ElementTyp.WATER);
    }
    @Test
    public void test_getCardType() {
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.SPELL);
        CardType cardType = card.getCardType();
        assertTrue(cardType == CardType.SPELL);
    }
    @Test
    public void test_getEffectivenessAgainst() {
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.MONSTER);
        Card card2 = new Card("Name", 10, ElementTyp.WATER, CardType.MONSTER);
        EffectivnessType effectivnessType = card.getEffectivenessAgainst(card2);
        assertTrue(effectivnessType == EffectivnessType.NOEFFECT);
    }
    @Test
    public void test_setName() {
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.SPELL);
        card.setName("NeuerName");
        assertTrue(card.getName().equals("NeuerName"));
    }
    @Test
    public void test_setDamage() {
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.SPELL);
        card.setDamage(100);
        assertTrue(card.getDamage() == 100);
    }
    @Test
    public void test_setElementTyp() {
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.SPELL);
        card.setElementType(ElementTyp.FIRE);
        assertTrue(card.getElementTyp() == ElementTyp.FIRE);
    }
}
